/*
 * def.h
 *
 *  Created on: 22.07.2012
 *      Author: cyblord
 */

#ifndef DEF_H_
#define DEF_H_

#define SDA			PB0
#define SCL			PB1



#define VSENSE_ON
#define VIN_PORT		0 // (PB5)
#ifdef ADC_DIVIDER_10k_1k3
#define ADC_MULTIPLIER		3729
#define ADC_DIVISOR			13312
#endif

#ifdef ADC_DIVIDER_10k_2k2
#define ADC_MULTIPLIER		183
#define ADC_DIVISOR			1024
#endif

#define ADR_R		0xEF
#define ADR_W		0xEE
#define OSS			3

#define VERSION		31

#define ALERT_MIN	-16384
#define ALERT_MAX	16383

typedef struct Alert {
	int16_t min;
	int16_t max;
} __attribute__((packed)) Alert_t;

typedef struct Config {
	uint8_t adr_alt;
	uint8_t adr_maxalt;
	uint8_t adr_temp;
	uint8_t adr_volt;
	uint8_t adr_vario;
	uint8_t adr_minvario;
	uint8_t adr_maxvario;
	Alert_t alert_alt;
	Alert_t alert_temp;
	Alert_t alert_volt;
	uint8_t vario_th_up;
	uint8_t vario_th_lo;
}__attribute__((packed)) Config_t;

typedef struct bmp085_data {
	int16_t temperature;
	uint32_t pressure;
} bmp085_data_t;


#define ADR_DISABLED	0xFF
#define ADR_VALID(adr)(adr<16)

#define CMD_SENDDATA	0x45
#define CMD_RECDATA		0x46
#define CMD_RESET		0x47
#define CMD_ECHO		0x48

#define START			2
#define END				3
#define ACK				6
#define NAK				21

#endif /* DEF_H_ */
