/*
 * i2c.c
 *
 *  Created on: 09.05.2012
 *      Author: cyblord
 */

#include <avr/io.h>
#include <compat/deprecated.h>
#include <util/delay.h>
#include "i2c.h"


void i2C_sda_rel() {
	cbi(I2C_DIR,I2C_SDA); //SDA=Eingang
	sbi(I2C_PORT,I2C_SDA); //Pullup
}

void i2c_sda_lo() {
	sbi(I2C_DIR,I2C_SDA); //SDA=Ausgang
	cbi(I2C_PORT,I2C_SDA); //Lo
}

void i2c_init() {
	sbi(I2C_DIR,I2C_SCL); //SCL Ausgang
	i2c_scl_hi();
	i2C_sda_rel();
}



void i2c_start() {
	i2c_scl_hi();
	i2c_delay();
	i2c_sda_lo();
	i2c_delay();
	i2c_scl_lo();
	i2c_delay();
}

void i2c_stop() {
	i2c_sda_lo();
	i2c_delay();
	i2c_scl_hi();
	i2c_delay();
	i2C_sda_rel();
	i2c_delay();
}

void i2c_clock() {
	i2c_scl_hi();
	i2c_delay();
	i2c_scl_lo();
	i2c_delay();
}

uint8_t i2c_send(uint8_t d) {
	for (int i=0;i<8;i++) {
		if (d & 128) i2C_sda_rel(); else i2c_sda_lo();
		i2c_delay();
		i2c_clock();
		d=d<<1;
	}
	i2C_sda_rel();
	i2c_delay();
	i2c_scl_hi();
	i2c_delay();
	uint8_t ack=i2c_is_sda();
	i2c_scl_lo();
	return ack;
}

uint8_t i2c_receive(uint8_t ack) {
	i2C_sda_rel();
	uint8_t result=0;
	for (int i=0;i<8;i++) {
		result=result<<1;
		i2c_scl_hi();
		i2c_delay();
		if (i2c_is_sda()) result++;
		i2c_scl_lo();
		i2c_delay();
	}
	if (ack) i2c_sda_lo(); else i2C_sda_rel();
	i2c_clock();
	i2C_sda_rel();
	i2c_delay();
	return result;
}



