/*
 * i2c.h
 *
 *  Created on: 09.05.2012
 *      Author: cyblord
 */
#include "defs.h"

#ifndef I2C_H_
#define I2C_H_

#define I2C_PORT	PORTB
#define I2C_DIR		DDRB
#define I2C_PIN		PINB

#define I2C_SDA		SDA
#define I2C_SCL		SCL

#define i2c_scl_hi()(sbi(I2C_PORT,I2C_SCL))
#define i2c_scl_lo()(cbi(I2C_PORT,I2C_SCL))

#define i2c_is_sda()(bit_is_set(I2C_PIN,I2C_SDA))

#define i2c_delay()(_delay_us(5))

void i2c_init();
void i2c_start();
void i2c_stop();
uint8_t i2c_send(uint8_t data);
uint8_t i2c_receive(uint8_t ack);



#endif /* I2C_H_ */
