/*
 * mbus.h
 *
 *  Created on: 15.03.2012
 *      Author: cyblord
 */


#ifndef MBUS_H_
#define MBUS_H_

#define MB_BITLEN		25 // 38400 Baud @ 8 MHz
#define MB_BUS_LO() (sbi(MB_DDR,MB_BUS))
#define MB_BUS_REL() (cbi(MB_DDR,MB_BUS))
#define MB_IS_BUS()(bit_is_set(MB_PIN,MB_BUS))

#define MB_SPECIAL		0
#define MB_VOLTAGE		1
#define MB_CURRENT		2
#define MB_VARIO		3
#define MB_SPEED		4
#define MB_RPM			5
#define MB_TEMP			6
#define MB_DIR			7
#define MB_ALT			8
#define MB_TANK			9
#define MB_LQI			10
#define MB_CAP			11
#define MB_FLUID		12
#define MB_LDIST		13

#define MB_NOALERT		0
#define MB_ALERT		1

#define MB_CMD_RESET			0x5A
#define MB_CMD_RESERVED_MIN		0x80
#define MB_CMD_RESERVED_MAX		0x8F

#define MB_NOVALUE		0x8000

#define MB_MAX_ADRESS	15

typedef struct MB_DATA {
	uint8_t active;
	uint8_t response[3];
} MB_DATA_T;

extern volatile uint8_t mb_afterRequestByte;

//Interface
void mb_init();
void mb_update(uint8_t adr,uint8_t uni,int16_t value,uint8_t alert);
void mb_novalue(uint8_t adr,uint8_t unit);
void mb_setCommandCallback(void (*commandReceived)(uint8_t));
void mb_send(uint8_t data);
void mb_sendString(char* s);
uint8_t mb_receive();
uint8_t mb_receiveBlocked();
uint8_t mb_isStart();

#endif /* MBUS_H_ */
